﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using HeuristicLab.MainForm;
using HeuristicLab.Optimization.Views;
using HeuristicLab.Core.Views;

namespace HeuristicLab.HiveEngine.Views {
  [View("Hive Engine View")]
  [Content(typeof(HiveEngine), IsDefaultView = true)]
  public sealed partial class HiveEngineView : EngineView {
    public new HiveEngine Content {
      get { return (HiveEngine)base.Content; }
      set { base.Content = value; }
    }

    public HiveEngineView() {
      InitializeComponent();
    }

    protected override void DeregisterContentEvents() {
      // TODO: Deregister your event handlers here
      base.DeregisterContentEvents();
    }

    protected override void RegisterContentEvents() {
      base.RegisterContentEvents();
      // TODO: Register your event handlers here
    }

    #region Event Handlers (Content)
    // TODO: Put event handlers of the content here
    #endregion

    protected override void OnContentChanged() {
      base.OnContentChanged();
      if (Content == null) {
        // TODO: Add code when content has been changed and is null
      } else {
        // TODO: Add code when content has been changed and is not null
      }
    }


    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
      // Enable or disable controls based on whether the content is null or the view is set readonly
      if (Content != null) {
        resourceIdsTextBox.ReadOnly = this.ReadOnly;
      } else {
        resourceIdsTextBox.ReadOnly = false;
      }
    }
    
    #region Event Handlers (child controls)
    private void resourceIdsTextBox_TextChanged(object sender, EventArgs e) {
      Content.ResourceIds = resourceIdsTextBox.Text;
    }
    #endregion
  }
}
